<template>
  <div :class="{'paused': !playing, 'landed': landed}" class="fallingObject" :style="{right: horizontalPosition, bottom: distanceFromBar}">
    <in-object :shape="shape" :weight="weight"></in-object>
  </div>
</template>

<style lang="scss" scoped>
@keyframes falling {
  0% {
    bottom: 80%;
  }
  100% {
    bottom: 0;
  }
}

.fallingObject {
  position: absolute;
  right: 210px;
  bottom: 80%;
  transition: right .3s linear;
  animation-name: falling;
  animation-duration: 4000ms;
  animation-fill-mode: forwards;
}
.paused {
  animation-play-state: paused;
}
.landed {
  animation: none;
}
</style>

<script>
import inObject from './inObject';

export default {
  name: 'falling-object',
  props: {
    index: {
      type: Number,
      required: true
    }
  },
  components: {
    inObject
  },
  computed: {
    object() {
      return this.$store.state.leftSideObjects[this.index];
    },
    bendingPercentage() {
      return this.$store.state.bendingPercentage;
    },
    horizontalPosition() {
      return `${this.offset * 70}px`;
    },
    shape() {
      if (this.object) {
        return this.object.shape;
      }
      return null;
    },
    weight() {
      if (this.object) {
        return this.object.weight;
      }
      return null;
    },
    landed() {
      if (this.object) {
        return this.object.landed;
      }
      return null;
    },
    playing() {
      return this.$store.state.playing;
    },
    distanceFromBar() {
      if (this.landed) {
        if (Math.sign(this.bendingPercentage) === -1) {
          return `${-Math.abs(this.bendingPercentage / 2) * (this.offset - .5)}px !important`;
        } else {
          return `${Math.abs(this.bendingPercentage / 2) * (this.offset - .5)}px !important`;
        }
      }
      return '';
    }
  },
  methods: {
    moveToLeft() {
      if (this.offset !== 0 && !this.landed) {
        this.offset = this.offset - 1;
      }
    },
    moveToRight() {
      if (this.offset !== 5 && !this.landed) {
        this.offset = this.offset + 1;
      }
    }
  },
  watch: {
    landed() {
      this.$store.commit('calculateLeftSideTotalWeight', {
        weight: this.weight,
        offset: this.offset
      });
      this.$store.commit('calculateBending');
    }
  },
  mounted() {
    const vueScope = this;
    window.addEventListener('keydown', function(e) {
      if (e.keyCode === 39) {
        vueScope.moveToLeft();
      }
    });
    window.addEventListener('keydown', function(e) {
      if (e.keyCode === 37) {
        vueScope.moveToRight();
      }
    });
  },
  data() {
    return {
      offset: 3
    }
  }
}
</script>